PROGRAM Crout;

USES Crt;

CONST NN=13;

TYPE Matrice=ARRAY[1..NN,1..NN] OF REAL;
     Vecteur=ARRAY[1..NN] OF REAL;

VAR MatA,MatB,MatC,MatD,MatInv:Matrice;
    N:BYTE;
    OK:BOOLEAN;
    x,y:Vecteur;

PROCEDURE Intro(VAR N:BYTE;VAR Mat:Matrice);
VAR i,j:BYTE;
BEGIN
CLRSCR;
WRITE('Nombre de lignes:');READLN(N);
FOR i:=1 TO N DO
  FOR j:=1 TO N+1 DO
    BEGIN
    GOTOXY(3,4);CLREOL;
    WRITE('Introduisez A(',i,',',j,'):');
    READLN(Mat[i,j]);
    END;
END;

PROCEDURE Affiche(Message:STRING;CDebut,LDebut,N:BYTE;Mat:Matrice);
VAR i,j,Lg:BYTE;
BEGIN
CLRSCR;Lg:=9;
TEXTCOLOR(LIGHTGREEN);
WRITELN(Message);
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    GOTOXY(CDebut+2+(j-1)*(Lg+1),LDebut+i*2-1);WRITE(Mat[i,j]:5:4);
    END;
WRITELN;READKEY;
END;

PROCEDURE AfficheV(Message:STRING;CDebut,LDebut,N:BYTE;Mat:Vecteur);
VAR i,j,Lg:BYTE;
BEGIN
CLRSCR;Lg:=19;
TEXTCOLOR(LIGHTGREEN);
WRITELN(Message);
FOR i:=1 TO N DO
    BEGIN
    GOTOXY(CDebut+Lg,LDebut+i*2-1);WRITE('X[',i,']=',Mat[i]:5:4);
    END;
WRITELN;READKEY;
END;

PROCEDURE Produit(N:BYTE;MatA,MatB:Matrice;VAR MatC:Matrice);
VAR i,j,k:BYTE;
BEGIN
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    MatC[i,j]:=0;
    FOR k:=1 TO N DO
      MatC[i,j]:=MatC[i,j]+MatA[i,k]*MatB[k,j];
    END;
END;

PROCEDURE Decompose2(N:BYTE;A:Matrice;VAR L,U:Matrice;VAR OK:BOOLEAN);{Dcomposition en utilisant 2 matrices pour L et U}
VAR i,j:BYTE;

FUNCTION SommeL(i,j:BYTE):REAL;
VAR S:REAL;
    k:BYTE;
BEGIN
S:=0;
FOR k:=1 TO j-1 DO
  S:=S+L[i,k]*U[k,j];
SommeL:=S;
END;

FUNCTION SommeU(i,j:BYTE):REAL;
VAR S:REAL;
    k:BYTE;
BEGIN
S:=0;
FOR k:=1 TO i-1 DO
  S:=S+L[i,k]*U[k,j];
SommeU:=S;
END;

BEGIN
OK:=TRUE;
FILLCHAR(L,SizeOf(L),0);
FILLCHAR(U,SizeOf(U),0);
IF A[1,1]=0 THEN OK:=FALSE
ELSE BEGIN
     FOR i:=1 TO N DO
       BEGIN
       L[i,1]:=A[i,1];
       U[1,i]:=A[1,i]/L[1,1];
       U[i,i]:=1
       END;
     OK:=TRUE;
     i:=1;
     WHILE NOT ((i=N) OR (OK=FALSE)) DO
       BEGIN
       i:=i+1;
       FOR j:=2 TO N DO
         IF i>=j THEN L[i,j]:=A[i,j]-SommeL(i,j)
         ELSE IF ABS(L[i,i])<1E-6 THEN OK:=FALSE
              ELSE U[i,j]:=(A[i,j]-SommeU(i,j))/L[i,i];
       END;
     END;
IF ABS(L[i,i])<1E-6 THEN OK:=FALSE;
IF OK THEN BEGIN
           Affiche('L=',1,1,N,L);
           Affiche('U=',1,1,N,U);
           Produit(N,L,U,MatD);
           Affiche('L*U=',1,1,N,MatD);
           END
ELSE BEGIN
     CLRSCR;
     WRITELN('Mthode inadquate ou systme  dterminant nul.');
     READKEY;
     END;
END;


PROCEDURE Decompose1(N:BYTE;A:Matrice;VAR B:Matrice;VAR OK:BOOLEAN);{Dcomposition en utilisant une seule matrice pour L et U}
VAR i,j:BYTE;

FUNCTION MatL(i,j:BYTE):REAL;
BEGIN
IF i<j THEN MatL:=0
ELSE MatL:=B[i,j]
END;

FUNCTION MatU(i,j:BYTE):REAL;
BEGIN
IF i>j THEN MatU:=0
ELSE IF i=j THEN MatU:=1
     ELSE MatU:=B[i,j]
END;

PROCEDURE Produit(VAR C:Matrice);
VAR i,j,k:BYTE;
BEGIN
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    C[i,j]:=0;
    FOR k:=1 TO N DO
      C[i,j]:=C[i,j]+MatL(i,k)*MatU(k,j);
    END;
END;

FUNCTION SommeL(i,j:BYTE):REAL;
VAR S:REAL;
    k:BYTE;
BEGIN
S:=0;
FOR k:=1 TO j-1 DO
  S:=S+B[i,k]*B[k,j];
SommeL:=S;
END;

FUNCTION SommeU(i,j:BYTE):REAL;
VAR S:REAL;
    k:BYTE;
BEGIN
S:=0;
FOR k:=1 TO i-1 DO
  S:=S+B[i,k]*B[k,j];
SommeU:=S;
END;

BEGIN
OK:=TRUE;
FILLCHAR(B,SizeOf(B),0);
IF A[1,1]=0 THEN OK:=FALSE
ELSE BEGIN
     B[1,1]:=A[1,1];
     FOR i:=2 TO N DO
       BEGIN
       B[i,1]:=A[i,1];
       B[1,i]:=A[1,i]/B[1,1];
       END;
     OK:=TRUE;
     i:=1;
     WHILE NOT ((i=N) OR (OK=FALSE)) DO
       BEGIN
       i:=i+1;
       FOR j:=2 TO N DO
         IF i>=j THEN B[i,j]:=A[i,j]-SommeL(i,j)
         ELSE IF ABS(B[i,i])<1E-6 THEN OK:=FALSE
              ELSE B[i,j]:=(A[i,j]-SommeU(i,j))/B[i,i];
       END;
     END;
IF OK THEN BEGIN
           Affiche('L et U combines:',1,1,N,B);
           Produit(MatD);
           Affiche('L*U=',1,1,N,MatD);
           END
ELSE BEGIN
     CLRSCR;
     WRITELN('Mthode inadquate ou systme  dterminant nul.');
     READKEY;
     END;
END;

PROCEDURE CalculeY;
VAR i,k:BYTE;
    Som:REAL;
BEGIN
Y[1]:=MatA[1,N+1]/MatB[1,1];
FOR i:=2 TO N DO
  BEGIN
  Som:=0;
  FOR k:=1 TO i-1 DO
    Som:=Som+MatB[i,k]*Y[k];
  Y[i]:=(MatA[i,N+1]-Som)/MatB[i,i];
  END;
END;

PROCEDURE CalculeX;
VAR i,k:BYTE;
    Som:REAL;
BEGIN
X[N]:=Y[N];
FOR i:=N-1 DOWNTO 1 DO
  BEGIN
  Som:=0;
  FOR k:=i+1 TO N DO
    Som:=Som+MatC[i,k]*X[k];
  X[i]:=Y[i]-Som;
  END;
END;

VAR i,j:BYTE;

BEGIN
Intro(N,MatA);
Affiche('A=',1,1,N,MatA);
{Decompose1(N,MatA,MatB,OK);}
Decompose2(N,MatA,MatB,MatC,OK);
IF NOT OK THEN HALT;
CalculeY;
CalculeX;
AfficheV('Solution :',1,1,N,X);
END.