unit GaussU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    GBNbLignes: TGroupBox;
    SpinEdit1: TSpinEdit;
    SGDataA: TStringGrid;
    RadioGroup1: TRadioGroup;
    RBInverse: TRadioButton;
    RBResolution: TRadioButton;
    RBDeterminant: TRadioButton;
    BCalcule: TButton;
    BQuitte: TButton;
    procedure SpinEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RBInverseClick(Sender: TObject);
    procedure RBDeterminantClick(Sender: TObject);
    procedure RBResolutionClick(Sender: TObject);
    procedure BQuitteClick(Sender: TObject);
    procedure BCalculeClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

TYPE Tabl=ARRAY[1..30,1..30] OF REAL;

VAR A:Tabl;
    N,NC:BYTE; (* N=nbre de lignes, NC=nbre de colonnes, depend du type de problme *)
    IL,IC:ARRAY[1..30] OF BYTE; (* Retient ) chaque tape le n de la ligne et de la colonne du pivot *)
    LigneUtilisee,ColonneUtilisee:ARRAY[1..30] OF BOOLEAN; (* Retiennent si les lignes/colonnes ont dj utilises et o on ne peut plus chercher de pivot *)
    Det:REAL;

PROCEDURE AcquistionDonnees;
BEGIN
N:=Form1.SpinEdit1.Value;
END;

PROCEDURE Init;
VAR i:BYTE;
BEGIN
FOR i:=1 TO N DO
  BEGIN
  LigneUtilisee[i]:=FALSE;
  ColonneUtilisee[i]:=FALSE;
  END
END;

PROCEDURE RecherchePivot(VAR Pivt:REAL;VAR r,s:BYTE);
VAR i,j:BYTE;
BEGIN
Pivt:=0;
FOR i:=1 TO N DO
  BEGIN
  IF LigneUtilisee[i] THEN
  ELSE FOR j:=1 TO N DO
         IF ColonneUtilisee[j] THEN
         ELSE IF ABS(A[i,j])>ABS(Pivt) THEN BEGIN
                                            r:=i;s:=j;Pivt:=A[i,j]
                                            END

  END;
END;

PROCEDURE Rectangle(r,s:BYTE);
VAR i,j:BYTE;
    Pivt:REAL;
BEGIN
Pivt:=A[r,s];
FOR i:=1 TO r-1 DO (* lignes avant celle du pivot *)
  BEGIN
  FOR j:=1 TO s-1 DO (* colonnes avant celle du pivot *)
    A[i,j]:=(A[i,j]*Pivt-A[r,j]*A[i,s])/Pivt;
  FOR j:=s+1 TO NC DO  (* colonnes aprs celle du pivot *)
    A[i,j]:=(A[i,j]*Pivt-A[r,j]*A[i,s])/Pivt;
  A[i,s]:=0;
  END;
FOR i:=r+1 TO N DO (* lignes aprs celle du pivot *)
  BEGIN
  FOR j:=1 TO s-1 DO (* colonnes avant celle du pivot *)
    A[i,j]:=(A[i,j]*Pivt-A[r,j]*A[i,s])/Pivt;
  FOR j:=s+1 TO NC DO  (* colonnes aprs celle du pivot *)
    A[i,j]:=(A[i,j]*Pivt-A[r,j]*A[i,s])/Pivt;
  A[i,s]:=0;
  END;
FOR j:=1 TO NC DO (* ligne du pivot *)
  A[r,j]:=A[r,j]/Pivt;
END;

PROCEDURE Swap(VAR a,b:REAL);
VAR Tmp:REAL;
BEGIN
Tmp:=a;
a:=b;
b:=Tmp
END;

PROCEDURE SwapI(VAR a,b:BYTE);
VAR Tmp:BYTE;
BEGIN
Tmp:=a;
a:=b;
b:=Tmp
END;

PROCEDURE RemetsDsOrdre;
VAR i,j,IL2,IC2:BYTE;
BEGIN
FOR i:=1 TO N DO
  BEGIN
  FOR j:=1 TO N DO (* On cherche l'inconnue # i *)
    BEGIN
    IF IL[j]=i THEN IL2:=j; (* elle se trouve ds la ligne IL2 *)
    IF IC[j]=i THEN IC2:=j; (* il faut inverser les lignes IL2 et IC2 *)
    END;
  IF IL2=IC2 THEN
  ELSE BEGIN
       SwapI(IC[IL2],IC[IC2]);
       FOR j:=1 TO NC DO
         Swap(A[IL2,j],A[IC2,j]);
       Det:=-Det
       END;
  END;
END;

PROCEDURE AfficheSol;
VAR i,j:BYTE;
BEGIN
RemetsDsOrdre;
IF Form1.RBResolution.Checked THEN BEGIN
                                   FOR i:=1 TO N DO
                                     FOR j:=1 TO N+1 DO
                                       Form1.SGDataA.Cells[j,i]:=FloatToStr(A[i,j]);
                                   END
ELSE IF Form1.RBInverse.Checked THEN FOR i:=1 TO N DO
                                       FOR j:=1 TO N DO
                                         Form1.SGDataA.Cells[j,i]:=FloatToStr(A[i,N+j])
     ELSE BEGIN
          ShowMessage('Det = '+FloatToStr(Det))
          END
END;

PROCEDURE Resol;
VAR Etap,r,s:BYTE;
    Pivt:REAL;
BEGIN
Etap:=1;
RecherchePivot(Pivt,r,s);
WHILE NOT ((Etap=N) OR (ABS(Pivt)<1E-6)) DO
  BEGIN
  IL[Etap]:=r;LigneUtilisee[r]:=TRUE; (* on retient la ligne o le pivot vient d'tre trouv *)
  IC[Etap]:=s;ColonneUtilisee[s]:=TRUE; (* on retient la colonne o le pivot vient d'tre trouv *)
  Rectangle(r,s); (* rgle du rectangle *)
  Det:=Det*Pivt;
  INC(Etap);
  RecherchePivot(Pivt,r,s);
  END;
IF ABS(Pivt)<1E-6 THEN ShowMessage('Systme  dterminant nul!')
ELSE BEGIN
     IL[Etap]:=r;LigneUtilisee[r]:=TRUE;
     IC[Etap]:=s;ColonneUtilisee[s]:=TRUE;
     Rectangle(r,s);
     Det:=Det*Pivt;
     AfficheSol;
     END;
END;

PROCEDURE CreeStringGrid;
VAR i:BYTE;
begin
WITH Form1 DO
BEGIN
N:=SpinEdit1.Value;
SGDataA.RowCount:=N+1;
SGDataA.ColCount:=N+1;
FOR i:=1 TO N DO
  BEGIN
  SGDataA.Cells[i,0]:=IntToStr(i);
  SGDataA.Cells[0,i]:=IntToStr(i);
  END;
IF RBResolution.Checked THEN BEGIN
                             SGDataA.ColCount:=N+2;
                             SGDataA.Cells[N+1,0]:='terme indpendant';
                             END;
SGDataA.Width:=30+SGDataA.DefaultColWidth*SGDataA.ColCount;
SGDataA.Height:=30+SGDataA.DefaultRowHeight*SGDataA.RowCount;
END;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
CreeStringGrid;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
CreeStringGrid;
end;

procedure TForm1.RBInverseClick(Sender: TObject);
begin
CreeStringGrid;
end;

procedure TForm1.RBDeterminantClick(Sender: TObject);
begin
CreeStringGrid;
end;

procedure TForm1.RBResolutionClick(Sender: TObject);
begin
CreeStringGrid;
end;

procedure TForm1.BQuitteClick(Sender: TObject);
begin
CLOSE
end;

procedure TForm1.BCalculeClick(Sender: TObject);
VAR i,j:BYTE;
begin
Init;Det:=1;
NC:=N;
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    IF SGDataA.Cells[j,i]='' THEN EXIT;
    try
      A[i,j]:=StrToFloat(SGDataA.Cells[j,i]);
    except
      on E: EConvertError do
        BEGIN
        ShowMessage(E.Message);
        EXIT;
        END;
    end;
    END;
IF RBInverse.Checked THEN BEGIN
                          NC:=2*N;
                          FOR i:=1 TO N DO
                            BEGIN
                            FOR j:=N+1 TO NC DO
                              A[i,j]:=0;
                            A[i,N+i]:=1;
                            END;
                          END
ELSE IF RBResolution.Checked THEN BEGIN
                                  FOR i:=1 TO N DO
                                    A[i,N+1]:=StrToFloat(SGDataA.Cells[N+1,i]);
                                  NC:=N+1;
                                  END;
Resol;
end;

end.
