unit KochU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    BSuivant: TButton;
    BQuitter: TButton;
    ColorDialog1: TColorDialog;
    Options: TMainMenu;
    Couleurdefond1: TMenuItem;
    Couleurdudessin1: TMenuItem;
    Couleurdefond2: TMenuItem;
    Recommncer1: TMenuItem;
    Sanstapeprcdente1: TMenuItem;
    Avectapeprcdente1: TMenuItem;
    BPrecedent: TButton;
    procedure BQuitterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BSuivantClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Couleurdudessin1Click(Sender: TObject);
    procedure Couleurdefond2Click(Sender: TObject);
    procedure Recommncer1Click(Sender: TObject);
    procedure Sanstapeprcdente1Click(Sender: TObject);
    procedure Avectapeprcdente1Click(Sender: TObject);
    procedure BPrecedentClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

VAR x,y:ARRAY [0..4*65536] OF REAL;
    sin60,cos60:REAL;
    Max,Gen,Puiss4:WORD;
    Clear:BOOLEAN;

procedure TForm1.BQuitterClick(Sender: TObject);
begin
CLOSE
end;

PROCEDURE Genere(Gen:BYTE);
VAR i,j:WORD;
    dx,dy:REAL;
BEGIN
FOR j:=Puiss4*3 DOWNTO 1 DO //On dcale les points pour intercaler les 3 nveaux points
  BEGIN
  x[j*4]:=x[j];
  y[j*4]:=y[j];
  END;
FOR j:=0 TO Puiss4*3-1 DO //On intercale les 3 nveaux points
    BEGIN
    i:=4*j;
    dx:=(x[i+4]-x[i])/3;dy:=(y[i+4]-y[i])/3;  //on coupe en 3
    x[i+1]:=x[i]+dx;y[i+1]:=y[i]+dy;          //on part du 1/3 et on termine aux 2/3
    x[i+2]:=x[i+1]+cos60*dx+sin60*dy;         //on obtient le nouveau point,
    y[i+2]:=y[i+1]-sin60*dx+cos60*dy;         //sommet du triangle quiltral
    x[i+3]:=x[i]+2*dx;y[i+3]:=y[i]+2*dy;
    END;
END;

PROCEDURE Dessine(Gen:WORD);
VAR i:WORD;
    S:STRING;
BEGIN
IF Clear THEN BEGIN // on efface le dessin
              Max:=Form1.PaintBox1.Width;
              Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
              END;
WITH Form1.PaintBox1.Canvas DO
  BEGIN
  MoveTo(TRUNC(x[0]),TRUNC(y[0])); // on va au 1er point
  FOR i:=1 TO 3*Puiss4 DO
    LineTo(TRUNC(x[i]),TRUNC(y[i])); // on trace de point en point
  END;
Form1.PaintBox1.Canvas.TextOut(20,Max-20,'Gnration : '+IntToStr(Gen)+'     ');
S:='Nombre de cts : '+IntToStr(3*Puiss4)+'     ';
Form1.PaintBox1.Canvas.TextOut(Max-15-Form1.PaintBox1.Canvas.TextWidth(S),Max-20,S);
END;

PROCEDURE Init;
VAR L:WORD;
BEGIN
Clear:=TRUE;                             // on va essacer par dfaut les anciens dessins
Form1.PaintBox1.Color:=ClWhite;          // sur un fond blanc
Form1.PaintBox1.Canvas.Pen.Color:=ClRed; // en rouge
Max:=Form1.PaintBox1.Width;              // taille du cadre
L:=4*Max DIV 5;                          // le 1er cote mesurera 2/3 du cadre
Sin60:=SQRT(3)/2;                        // sin (60) pour les deplacements
Cos60:=0.5;                              // cos (60)
x[0]:=(Max-L) DIV 2;                     // 1er point
y[0]:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;      // hauteur max = hauteur 1er triangle (=L*Sin60)+ hauteur 1 triangle ajoute (=L/3*Sin60)
x[1]:=x[0]+L*Cos60;                      // 2eme point
y[1]:=y[0]-L*Sin60;
x[2]:=x[0]+L;                            // 3eme point
y[2]:=y[0];
x[3]:=x[0];
y[3]:=y[0];
Gen:=1;Puiss4:=1;                        // Gnration # 1 et 3*Puiss4 points
END;

procedure TForm1.FormCreate(Sender: TObject);
begin
Init;
end;

procedure TForm1.BSuivantClick(Sender: TObject);
begin
IF Puiss4>=16384 THEN Exit; // cf place rserve dans les tableaux
Puiss4:=Puiss4*4;
INC(Gen);
Genere(Gen);
Dessine(Gen);
end;

PROCEDURE Effacer;
BEGIN
Max:=Form1.PaintBox1.Width;
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
Dessine(Gen);
END;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 with Sender as TPaintBox do
  begin
  Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
  Dessine(1);
  end;
end;

procedure TForm1.Couleurdudessin1Click(Sender: TObject);
begin
if ColorDialog1.Execute then BEGIN
                             Form1.PaintBox1.Canvas.Pen.Color := ColorDialog1.Color;
                             Effacer
                             END;
end;

procedure TForm1.Couleurdefond2Click(Sender: TObject);
begin
if ColorDialog1.Execute then BEGIN
                             Form1.PaintBox1.Color := ColorDialog1.Color;
                             Effacer
                             END;
end;

procedure TForm1.Recommncer1Click(Sender: TObject);
VAR L:WORD;
begin
L:=4*Max DIV 5;                          // le 1er cote mesurera 2/3 du cadre
x[0]:=(Max-L) DIV 2;                     // 1er point
y[0]:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;      // hauteur max = hauteur 1er triangle (=L*Sin60)+ hauteur 1 triangle ajoute (=L/3*Sin60)
x[1]:=x[0]+L*Cos60;                      // 2eme point
y[1]:=y[0]-L*Sin60;
x[2]:=x[0]+L;                            // 3eme point
y[2]:=y[0];
x[3]:=x[0];
y[3]:=y[0];
Gen:=1;Puiss4:=1;                        // Gnration # 1 et 3*Puiss4 points

Effacer
end;

procedure TForm1.Sanstapeprcdente1Click(Sender: TObject);
begin
Clear:=TRUE;
end;

procedure TForm1.Avectapeprcdente1Click(Sender: TObject);
begin
Clear:=FALSE;
end;

procedure TForm1.BPrecedentClick(Sender: TObject);
VAR j:WORD;
begin
IF Puiss4=1 THEN Exit;
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max); // il faut effacer sinon on ne voit rien
FOR j:=1 TO Puiss4*3 DO                        // On dcale les points pour suppimer les 3 nveaux points
  BEGIN
  x[j]:=x[j*4];
  y[j]:=y[j*4];
  END;
Puiss4:=Puiss4 DIV 4;
DEC(Gen);
Dessine(Gen)
end;

end.
