unit KochU2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    BSuivant: TButton;
    BQuitter: TButton;
    ColorDialog1: TColorDialog;
    Options: TMainMenu;
    Couleurdudessin1: TMenuItem;
    Couleurdefond2: TMenuItem;
    Recommncer1: TMenuItem;
    Sanstapeprcdente1: TMenuItem;
    Avectapeprcdente1: TMenuItem;
    BPrecedent: TButton;
    procedure BQuitterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BSuivantClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Couleurdudessin1Click(Sender: TObject);
    procedure Couleurdefond2Click(Sender: TObject);
    procedure Recommncer1Click(Sender: TObject);
    procedure Sanstapeprcdente1Click(Sender: TObject);
    procedure Avectapeprcdente1Click(Sender: TObject);
    procedure BPrecedentClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

TYPE Point = RECORD
               x,y:REAL;
             END;

VAR a,b,c:Point;
    sin60,cos60:REAL;
    Max,Gen:WORD;
    Puiss4:LONGWORD;
    Clear:BOOLEAN;

procedure TForm1.BQuitterClick(Sender: TObject);
begin
CLOSE
end;

FUNCTION PointAligne(a,b:Point):Point;
BEGIN
PointAligne.x:=a.x+(b.x-a.x)/3; // valeur initiale + tiers de la longueur
PointAligne.y:=a.y+(b.y-a.y)/3;
END;

FUNCTION Sommet(a,b:Point):Point;
BEGIN
Sommet.x:=(a.x+b.x)*cos60-(b.y-a.y)*sin60; // une rotation de 60
Sommet.y:=(a.y+b.y)*cos60+(b.x-a.x)*sin60;
END;

PROCEDURE DessineC(a,b:Point;n:WORD);
VAR c,d,e:Point;
BEGIN
Form1.PaintBox1.Canvas.MoveTo(ROUND(a.x),ROUND(Max-a.y));
IF n>0 THEN BEGIN
            c:=PointAligne(a,b); // 1er point au tiers de ab
            d:=PointAligne(b,a); // 1eme point aux deux tiers de ab
            e:=Sommet(c,d);      // sommet du triangle gnr
            DessineC(a,c,n-1);   // on fait la mme chose sur ac (premier tiers)
            DessineC(c,e,n-1);   // on fait la mme chose sur ce (1er cote du triangle gnr)
            DessineC(e,d,n-1);   // on fait la mme chose sur ed (2eme cote du triangle gnr)
            DessineC(d,b,n-1);   // on fait la mme chose sur ab (dernier tiers)
            END
ELSE BEGIN
     Form1.PaintBox1.Canvas.LineTo(ROUND(b.x),ROUND(Max-b.y));
     END;
END;

PROCEDURE Dessine(Gen:WORD);
VAR S:STRING;
BEGIN
IF Clear THEN BEGIN // on efface le dessin
              Max:=Form1.PaintBox1.Width;
              Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
              END;
Form1.PaintBox1.Canvas.TextOut(20,Max-20,'Gnration : '+IntToStr(Gen+1)+'     ');
S:='Nombre de cts : '+IntToStr(3*Puiss4)+'     ';
Form1.PaintBox1.Canvas.TextOut(Max-15-Form1.PaintBox1.Canvas.TextWidth(S),Max-20,S);
DessineC(a,b,Gen); // on gnre le triangle sur ab
DessineC(b,c,Gen); // on gnre le triangle sur bc
DessineC(c,a,Gen); // on gnre le triangle sur ca
END;

PROCEDURE Init;
VAR i,L:WORD;
BEGIN
Clear:=TRUE;                             // on va essacer par dfaut les anciens dessins
Form1.PaintBox1.Color:=ClWhite;          // sur un fond blanc
Form1.PaintBox1.Canvas.Pen.Color:=ClRed; // en rouge
Max:=Form1.PaintBox1.Width;              // taille du cadre
L:=4*Max DIV 5;                          // le 1er cote mesurera 2/3 du cadre
Sin60:=SQRT(3)/2;                        // sin (60) pour les deplacements
Cos60:=0.5;                              // cos (60)
a.x:=(Max-L) DIV 2;                      // 1er point
a.y:=ROUND(L/3*Sin60)+ROUND(Max-4*L*Sin60/3) DIV 2;      // hauteur max = hauteur 1er triangle (=L*Sin60)+ hauteur 1 triangle ajoute (=L/3*Sin60)
c.x:=a.x+L;                              // 3eme point
c.y:=a.y;
b:=Sommet(a,c);                          // 2eme point
Gen:=0;                                  // Gnration # 0
Puiss4:=1;
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
END;

procedure TForm1.FormCreate(Sender: TObject);
begin
Init;
end;

procedure TForm1.BSuivantClick(Sender: TObject);
begin
INC(Gen);
Puiss4:=Puiss4 SHL 2;
Dessine(Gen);
end;

PROCEDURE Effacer;
BEGIN
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
Dessine(Gen);
END;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 with Sender as TPaintBox do
  begin
  Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
  Dessine(Gen);
  end;
end;


procedure TForm1.Couleurdudessin1Click(Sender: TObject);
begin
if ColorDialog1.Execute then BEGIN
                             Form1.PaintBox1.Canvas.Pen.Color := ColorDialog1.Color;
                             Effacer
                             END;
end;

procedure TForm1.Couleurdefond2Click(Sender: TObject);
begin
if ColorDialog1.Execute then BEGIN
                             Form1.PaintBox1.Color := ColorDialog1.Color;
                             Effacer
                             END;
end;

procedure TForm1.Recommncer1Click(Sender: TObject);
VAR L:WORD;
begin
L:=4*Max DIV 5;                          // le 1er cote mesurera 2/3 du cadre
a.x:=(Max-L) DIV 2;                      // 1er point
a.y:=ROUND(L/3*Sin60)+ROUND(Max-4*L*Sin60/3) DIV 2;      // hauteur max = hauteur 1er triangle (=L*Sin60)+ hauteur 1 triangle ajoute (=L/3*Sin60)
c.x:=a.x+L;                              // 3eme point
c.y:=a.y;
b:=Sommet(a,c);                          // 2eme point
Gen:=0;                                  // Gnration # 0
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
Puiss4:=1;
Effacer
end;

procedure TForm1.Sanstapeprcdente1Click(Sender: TObject);
begin
Clear:=TRUE;
end;

procedure TForm1.Avectapeprcdente1Click(Sender: TObject);
begin
Clear:=FALSE;
end;

procedure TForm1.BPrecedentClick(Sender: TObject);
VAR j:WORD;
begin
IF Gen=0 THEN Exit;
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max); // il faut effacer sinon on ne voit rien
DEC(Gen);Puiss4:=Puiss4 SHR 2;
Dessine(Gen)
end;

end.
