unit KochUP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    BSuivant: TButton;
    BQuitter: TButton;
    ColorDialog1: TColorDialog;
    Options: TMainMenu;
    Couleurdudessin1: TMenuItem;
    Couleurdefond2: TMenuItem;
    Recommncer1: TMenuItem;
    Sanstapeprcdente1: TMenuItem;
    Avectapeprcdente1: TMenuItem;
    BPrecedent: TButton;
    procedure BQuitterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BSuivantClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Couleurdudessin1Click(Sender: TObject);
    procedure Couleurdefond2Click(Sender: TObject);
    procedure Recommncer1Click(Sender: TObject);
    procedure Sanstapeprcdente1Click(Sender: TObject);
    procedure Avectapeprcdente1Click(Sender: TObject);
    procedure BPrecedentClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

TYPE Point=RECORD
             x,y:REAL;
           END;
     PtrPoint=^PointPtr;
     PointPtr=RECORD
                Pt:Point;
                Ptr:PtrPoint;
              END;

VAR x,y:ARRAY [0..4*65536] OF REAL;
    sin60,cos60:REAL;
    Max,Gen,Puiss4:WORD;
    Clear:BOOLEAN;
    Koch:PtrPoint;

procedure TForm1.BQuitterClick(Sender: TObject);
begin
CLOSE
end;

FUNCTION CreeNoeud:PtrPoint;
VAR P:PtrPoint;
BEGIN
NEW(P);
P^.Ptr:=NIL;
CreeNoeud:=P
END;

PROCEDURE Genere(Gen:BYTE;Koch:PtrPoint);
VAR i,j:WORD;
    x0,y0,x1,y1,dx,dy:REAL;
    P:Point;
    Koch2,Ptr:PtrPoint;
BEGIN
x0:=Koch^.Pt.x;y0:=Koch^.Pt.y;
WHILE NOT (Koch^.Ptr=NIL) DO
  BEGIN
  Koch2:=Koch^.Ptr;

  x1:=Koch2^.Pt.x;y1:=Koch2^.Pt.y;

  dx:=(x1-x0)/3;dy:=(y1-y0)/3;  //on coupe en 3

  Ptr:=CreeNoeud;
  Ptr.Pt.x:=x0+dx;             //on part du 1/3 et on termine aux 2/3
  Ptr.Pt.y:=y0+dy;
  Koch^.Ptr:=Ptr;
  Koch:=Ptr;

  Ptr:=CreeNoeud;
  Ptr.Pt.x:=x0+dx+cos60*dx+sin60*dy;         //on obtient le nouveau point,
  Ptr.Pt.y:=y0+dy-sin60*dx+cos60*dy;         //sommet du triangle quiltral
  Koch^.Ptr:=Ptr;
  Koch:=Ptr;

  Ptr:=CreeNoeud;
  Ptr.Pt.x:=x0+2*dx;
  Ptr.Pt.y:=y0+2*dy;
  Koch.Ptr:=Ptr;
  Ptr^.Ptr:=Koch2;
  Koch:=Koch2;

  x0:=x1;y0:=y1;
  END;
END;

PROCEDURE Dessine(Koch:PtrPoint;Gen:WORD);
VAR i:WORD;
    S:STRING;
    x0,y0:REAL;
BEGIN
IF Clear THEN BEGIN // on efface le dessin
              Max:=Form1.PaintBox1.Width;
              Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
              END;
WITH Form1.PaintBox1.Canvas DO
  BEGIN
  x0:=Koch^.Pt.x;y0:=Koch^.Pt.y;
  MoveTo(ROUND(x0),ROUND(y0)); // on va au 1er point
  WHILE NOT (Koch.Ptr=NIL) DO
    BEGIN
    Koch:=Koch.Ptr;
    x0:=Koch^.Pt.x;y0:=Koch^.Pt.y;
    LineTo(ROUND(x0),ROUND(y0)); // on trace de point en point
    END;
  END;
Form1.PaintBox1.Canvas.TextOut(20,Max-20,'Gnration : '+IntToStr(Gen)+'     ');
S:='Nombre de cts : '+IntToStr(3*Puiss4)+'     ';
Form1.PaintBox1.Canvas.TextOut(Max-15-Form1.PaintBox1.Canvas.TextWidth(S),Max-20,S);
END;

PROCEDURE Init;
VAR L:WORD;
    Ptr,Ptr2:PtrPoint;
BEGIN
Clear:=TRUE;                             // on va essayer par dfaut les anciens dessins
Form1.PaintBox1.Color:=ClWhite;          // sur un fond blanc
Form1.PaintBox1.Canvas.Pen.Color:=ClRed; // en rouge
Max:=Form1.PaintBox1.Width;              // taille du cadre
L:=4*Max DIV 5;                          // le 1er cote mesurera 2/3 du cadre
Sin60:=SQRT(3)/2;                        // sin (60) pour les deplacements
Cos60:=0.5;                              // cos (60)
Koch:=CreeNoeud;
Koch.Pt.x:=(Max-L) DIV 2;                // 1er point
Koch.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;      // hauteur max = hauteur 1er triangle (=L*Sin60)+ hauteur 1 triangle ajoute (=L/3*Sin60)
Ptr:=CreeNoeud;
Ptr.Pt.x:=(Max-L) DIV 2+L*Cos60;         // 2eme point
Ptr.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2;
Koch.Ptr:=Ptr;
Ptr2:=CreeNoeud;
Ptr2.Pt.x:=(Max-L) DIV 2+L;             // 3eme point
Ptr2.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;
Ptr.Ptr:=Ptr2;
Ptr:=CreeNoeud;
Ptr.Pt.x:=(Max-L) DIV 2;               // on revient au 1er point
Ptr.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;
Ptr2.Ptr:=Ptr;

Gen:=1;Puiss4:=1;                        // Gnration # 1 et 3*Puiss4 points
END;

procedure TForm1.FormCreate(Sender: TObject);
begin
Init;
end;

procedure TForm1.BSuivantClick(Sender: TObject);
VAR Size: Integer;
    Buffer: PChar;
begin
Puiss4:=Puiss4*4;
INC(Gen);
Genere(Gen,Koch);
Dessine(Koch,Gen);
end;

PROCEDURE Effacer;
BEGIN
Max:=Form1.PaintBox1.Width;
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
Dessine(Koch,Gen);
END;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 with Sender as TPaintBox do
  begin
  Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max);
  Dessine(Koch,1);
  end;
end;

procedure TForm1.Couleurdudessin1Click(Sender: TObject);
begin
if ColorDialog1.Execute then BEGIN
                             Form1.PaintBox1.Canvas.Pen.Color := ColorDialog1.Color;
                             Effacer
                             END;
end;

procedure TForm1.Couleurdefond2Click(Sender: TObject);
begin
if ColorDialog1.Execute then BEGIN
                             Form1.PaintBox1.Color := ColorDialog1.Color;
                             Effacer
                             END;
end;

procedure TForm1.Recommncer1Click(Sender: TObject);
VAR L:WORD;
    Ptr,Ptr2:PtrPoint;
begin
L:=4*Max DIV 5;                          // le 1er cote mesurera 2/3 du cadre
Koch:=CreeNoeud;
Koch.Pt.x:=(Max-L) DIV 2;                // 1er point
Koch.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;      // hauteur max = hauteur 1er triangle (=L*Sin60)+ hauteur 1 triangle ajoute (=L/3*Sin60)
Ptr:=CreeNoeud;
Ptr.Pt.x:=(Max-L) DIV 2+L*Cos60;         // 2eme point
Ptr.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2;
Koch.Ptr:=Ptr;
Ptr2:=CreeNoeud;
Ptr2.Pt.x:=(Max-L) DIV 2+L;             // 3eme point
Ptr2.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;
Ptr.Ptr:=Ptr2;
Ptr:=CreeNoeud;
Ptr.Pt.x:=(Max-L) DIV 2;               // on revient au 1er point
Ptr.Pt.y:=(Max-ROUND(4*L*Sin60/3)) DIV 2+L*Sin60;
Ptr2.Ptr:=Ptr;
Gen:=1;                                // Gnration # 1 et 3*Puiss4 points
Puiss4:=1;
Effacer
end;

procedure TForm1.Sanstapeprcdente1Click(Sender: TObject);
begin
Clear:=TRUE;
end;

procedure TForm1.Avectapeprcdente1Click(Sender: TObject);
begin
Clear:=FALSE;
end;

PROCEDURE Supprime1(VAR P:PtrPoint);
VAR P2:PtrPoint;
BEGIN
IF P^.Ptr=NIL THEN Exit;
P2:=P^.Ptr;
P^.Ptr:=P2^.Ptr
END;

procedure TForm1.BPrecedentClick(Sender: TObject);
VAR j:WORD;
    Ptr,Koch2:PtrPoint;
begin
IF Puiss4=1 THEN Exit;
Form1.PaintBox1.Canvas.Rectangle(0,0,Max,Max); // il faut effacer sinon on ne voit rien
Koch2:=Koch;
WHILE NOT (Koch.Ptr=NIL) DO
  BEGIN
  Supprime1(Koch);
  Supprime1(Koch);
  Supprime1(Koch);
  IF Koch.Ptr=NIL THEN
  ELSE Koch:=Koch.Ptr
  END;
Koch:=Koch2;
DEC(Gen);Puiss4:=Puiss4 DIV 4;
Dessine(Koch,Gen)
end;

end.
