unit PanU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    Matrice: TStringGrid;
    Inversion: TButton;
    Quit: TButton;
    GroupBox1: TGroupBox;
    SpinEdit1: TSpinEdit;
    Hasard: TButton;
    Clear: TButton;
    procedure FormCreate(Sender: TObject);
    procedure InversionClick(Sender: TObject);
    procedure QuitClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure HasardClick(Sender: TObject);
    procedure ClearClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


TYPE Matrice=ARRAY[1..20,1..20] OF REAL48;

VAR N:BYTE;
    A:Matrice;
    First:BOOLEAN;

PROCEDURE DessineGrille(N:BYTE);
VAR i,j:SHORTINT;
    T,T2:BYTE;
begin
T:=50;
WITH Form1 DO
  BEGIN
  T2:=T+2*Matrice.GridLineWidth;
  WIDTH:=194+N*T2;
  IF 50+N*T2<364 THEN HEIGHT:=364
  ELSE HEIGHT:=50+N*T2;
  Matrice.RowCount:=N;
  Matrice.ColCount:=N;
  Matrice.DefaultColWidth:=T;
  Matrice.DefaultRowHeight:=T;
  Matrice.Top:=(Form1.Height-(T2*N)) DIV 2-15;
  Matrice.Left:=164;//139+ROUND((Form1.Width-128-(T2*N))/2);
  Matrice.Height:=N*Matrice.DefaultRowHeight+ROUND(5+N*3*Matrice.GridLineWidth/2);
  IF First THEN Matrice.Height:=Matrice.Height+9;
  Matrice.Width:=Matrice.Height;
  FOR i:=1 TO N DO
    FOR j:=1 TO N DO
      Matrice.Cells[j-1,i-1]:='';
  END;
Form1.Matrice.Visible:=TRUE;
First:=FALSE;
end;

PROCEDURE Somme(N:BYTE;MatA,MatB:Matrice;VAR MatC:Matrice);
VAR i,j:BYTE;
BEGIN
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
     MatC[i,j]:=MatA[i,j]+MatB[i,j];
END;

PROCEDURE Difference(N:BYTE;MatA,MatB:Matrice;VAR MatC:Matrice);
VAR i,j:BYTE;
BEGIN
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
     MatC[i,j]:=MatA[i,j]-MatB[i,j];
END;

PROCEDURE Produit(N:BYTE;MatA,MatB:Matrice;VAR MatC:Matrice);
VAR i,j,k:BYTE;
BEGIN
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    MatC[i,j]:=0;
    FOR k:=1 TO N DO
      MatC[i,j]:=MatC[i,j]+MatA[i,k]*MatB[k,j];
    END;
END;

PROCEDURE Inverse(N:BYTE;A:Matrice);
VAR Id,E,B:Matrice;
    Err,Old,New:REAL48;
    Cpt:BYTE;

  FUNCTION Norme_Ligne(N:BYTE;B:Matrice):REAL48;
  VAR Tmp,Tmp2:REAL48;
      i,j:BYTE;
  BEGIN
  Tmp:=0;
  FOR i:=1 TO N DO
    BEGIN
    Tmp2:=0;
    FOR j:=1 TO N DO
      Tmp2:=Tmp2+ABS(B[i,j]);
    IF Tmp2>Tmp THEN Tmp:=Tmp2;
    END;
  Norme_Ligne:=Tmp
  END;

  FUNCTION Norme_Colonne(N:BYTE;B:Matrice):REAL48;
  VAR Tmp,Tmp2:REAL48;
      i,j:BYTE;
  BEGIN
  Tmp:=0;
  FOR i:=1 TO N DO
    BEGIN
    Tmp2:=0;
    FOR j:=1 TO N DO
      Tmp2:=Tmp2+ABS(B[j,i]);
    IF Tmp2>Tmp THEN Tmp:=Tmp2;
    END;
  Norme_Colonne:=Tmp
  END;

  PROCEDURE Init(N:BYTE;A:Matrice;VAR B:Matrice;VAR OK:BOOLEAN);
  VAR i,j:BYTE;
      T:REAL48;
  BEGIN
  Err:=1E-10;
  FILLCHAR(Id,SizeOf(Id),0);
  T:=Norme_Ligne(N,A)*Norme_Colonne(N,A);
  IF ABS(T)>1E-10 THEN BEGIN
                       OK:=TRUE;
                       FOR i:=1 TO N DO
                         BEGIN
                         Id[i,i]:=1;
                         B[i,i]:=A[i,i]/T;
                         FOR j:=i+1 TO N DO
                           BEGIN
                           B[i,j]:=A[j,i]/T;
                           B[j,i]:=A[i,j]/T;
                           END;
                         END;
                       END
  ELSE OK:=FALSE;
  END;

  PROCEDURE Calcule_E;
  VAR C:Matrice;
  BEGIN
  Produit(N,B,A,C);
  Difference(N,Id,C,E);
  END;

  PROCEDURE Calcule_B;
  VAR C,D:Matrice;
  BEGIN
  Somme(N,Id,E,D);
  Produit(N,D,B,C);
  B:=C
  END;

VAR OK:BOOLEAN;
VAR i,j:WORD;
    Temp:REAL48;
    Erreur:BOOLEAN;
BEGIN
Erreur:=FALSE;
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    IF Form1.Matrice.Cells[j-1,i-1]='' THEN Temp:=0
    ELSE TRY
           Temp:=StrToFloat(Form1.Matrice.Cells[j-1,i-1])
         EXCEPT ON E:EConvertError DO BEGIN
                                      Temp:=0;
                                      Form1.Matrice.Cells[j-1,i-1]:='';
                                      Erreur:=TRUE;
                                      END;
         END;
    A[i,j]:=Temp;
    END;
IF Erreur THEN BEGIN
               ShowMessage('Valeur(s) non numrique(s) dans la matrice!');
               EXIT;
               END;
Init(N,A,B,OK);
IF NOT OK THEN ShowMessage('Matrice nulle!')
ELSE BEGIN
     Calcule_E;
     Old:=Norme_Ligne(N,E);
     New:=Old;
     Cpt:=0;
     WHILE NOT ((New<Err) OR ((New>Old) AND (Cpt>5))) DO
       BEGIN
       Old:=New;
       Calcule_B;
       Calcule_E;
       New:=Norme_Ligne(N,E);
       INC(Cpt);
       END;
    IF New<=Err THEN FOR i:=1 TO N DO
                       FOR j:=1 TO N DO
                         Form1.Matrice.Cells[j-1,i-1]:=FloatToStrF(B[i,j],ffFixed,7,6)
    ELSE ShowMessage('Matrice singulire!')
    END;
END;

procedure TForm1.FormCreate(Sender: TObject);
BEGIN
First:=TRUE;
N:=SpinEdit1.Value;
end;

procedure TForm1.InversionClick(Sender: TObject);
begin
Inverse(N,A)
end;

procedure TForm1.QuitClick(Sender: TObject);
begin
CLOSE
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
N:=SpinEdit1.Value;
DessineGrille(SpinEdit1.Value);
First:=FALSE;
end;

procedure TForm1.HasardClick(Sender: TObject);
VAR i,j:WORD;
begin
N:=SpinEdit1.Value;
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    A[i,j]:=20-RANDOM(40);
    Form1.Matrice.Cells[j-1,i-1]:=FloatToStr(A[i,j]);
    END;
end;

procedure TForm1.ClearClick(Sender: TObject);
VAR i,j:WORD;
BEGIN
FOR i:=1 TO N DO
  FOR j:=1 TO N DO
    BEGIN
    A[i,j]:=0;
    Form1.Matrice.Cells[j-1,i-1]:='0';
    END;
end;

end.
