PROGRAM Splines;{(c) JMy 1992}
USES Crt,Graph;

VAR SX,SY,SF2:ARRAY[1..100] OF REAL;
    I,N,IJ,grDriver,grMode,Lx,Ly,SXP,SYP:INTEGER;
    X,Y,H,S,XMax,YMax,XMin,YMin,F2,pas:REAL;
    CHx,CHy:STRING[10];

FUNCTION FNTST(x:REAL):REAL;
BEGIN
FNTST:=sin(x)*exp(-X*X/2);
END;

PROCEDURE SPLINE(I:INTEGER;X:REAL);
VAR Temp,Temp2:REAL;
BEGIN
Temp:=(SX[I+1]-X)/H;
Temp2:=(X-SX[I])/H;
Y:=SY[I]*Temp
  +SY[I+1]*Temp2
  -H*H/6*SF2[I]*Temp*(1-Temp*Temp)
  -H*H/6*SF2[I+1]*Temp2*(1-Temp2*Temp2);
END;

{----------------------------- INITIALISATION ----------------------------}
PROCEDURE Initialisation;
VAR I:INTEGER;
    St:STRING;
BEGIN
TEXTBACKGROUND(BLACK);
CLRSCR;
TEXTCOLOR(LIGHTGREEN);
St:=' S P L I N E S ';
GOTOXY(1,40-LENGTH(St) DIV 2);WRITELN(St);
TEXTCOLOR(YELLOW);
WRITE('Introduisez le nombre de points: ');READLN(N);
WRITE('Introduisez la premire valeur de x: ');READLN(S);
WRITE('Introduisez le pas (x(i+1) - x(i)): ');READLN(H);
YMAX:= -1E+20;YMIN:= 1E+20;
FOR I:= 1 TO N DO
  BEGIN
  SX[I]:=S+(I-1)*H;
  SY[I]:=FNTST(SX[I]);
  IF SY[I]<YMIN THEN YMIN:=SY[I];
  IF SY[I]>YMAX THEN YMAX:=SY[I];
  END;
XMIN:=SX[1];XMAX:=SX[N];
grDriver := Detect;
InitGraph(grDriver,grMode,'');
LX:= GetMaxX-6;LY:=GetMaxY-6;
END;

{----------------------- SOLUTION SYSTEME f"(x(i)) -----------------------}
PROCEDURE Systeme;
VAR I:INTEGER;
    Err,Tot:REAL;
BEGIN
FOR I:= 1 TO N DO
  SF2[I]:=0;
ERR:= 1;
WHILE (ERR>0.00001) DO
  BEGIN
  ERR:=0;
  TOT:=0;
  FOR I:=2 TO N-1 do
    BEGIN
    F2:=SF2[I];
    SF2[I]:=(6*(SY[I+1]-SY[I])/H-6*(SY[I]-SY[I-1])/H-H*SF2[I-1]-H*SF2[I+1])/2/(H+H);
    ERR:=ERR+ABS(F2-SF2[I]);
    TOT:=TOT+ABS(SF2[I]);
    END;
  IF TOT<>0 THEN ERR:=ERR/TOT;
  END;
END;

{------------------------- CALIBRE LE GRAPHE -----------------------------}
PROCEDURE Calibre;
BEGIN
SXP:=3+LX-Trunc(-3+(X-XMIN)*LX/(XMAX-XMIN));
SYP:=3+Trunc(-3+(YMAX-Y)*LY/(YMAX-YMIN));
END;

{---------------------------- PLOT LES POINTS  ---------------------------}
PROCEDURE Plot_pts;
VAR IJ:INTEGER;
BEGIN
SetColor(LightCyan);
FOR IJ:=1 TO N do
  BEGIN
  X:=SX[IJ];
  Y:=SY[IJ];
  calibre;
  CIRCLE (SXP,SYP,3);
  END;
END;

{---------------------------- PLOT LES SPLINES ---------------------------}
PROCEDURE Plot_splines;
VAR IJ,k:INTEGER;
BEGIN
SetColor(Yellow);
SetTextStyle(TriplexFont, Horizdir, 4);
OutTextxy(0,0,' Splines ');
pas:= H/100;
FOR IJ:=1 TO N-1 do
  BEGIN
  X:=SX[IJ];
  Y:=SY[IJ];
  calibre;
  PutPixel (SXP, SYP,Yellow);
  For k:=1 to 100 do
    BEGIN
    X:=SX[IJ]+k*pas;
    SPLINE(IJ,X);
    calibre;
    PutPixel (SXP, SYP,Yellow);
    END;
  END;
END;

{---------------------------- PLOT LA FONCTION ---------------------------}
PROCEDURE Plot_Function;
VAR No,k:INTEGER;
BEGIN
SETCOLOR(LIGHTGREEN);
SETTEXTSTYLE(TriplexFont, Horizdir, 4);
OUTTEXTXY(0,40,' Fonction ');
X:=SX[1];
Y:=SY[1];
calibre;
No:=LX;
PutPixel (SXP, SYP,LightGreen);
Pas:=(XMAX-XMIN)/No;
FOR k:=1 TO No DO
  BEGIN
  X:=XMIN+k*Pas;
  Y:=FNTST(X);
  calibre;
  PutPixel (SXP, SYP,LightGreen);
  END;
END;

{--------------------------- PROGRAMME PRINCIPAL -------------------------}
BEGIN
Initialisation;
systeme;
plot_pts;
plot_splines;
plot_function;
REPEAT
UNTIL KEYPRESSED;
CloseGraph
END.
